'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _slicedToArray2;

function _load_slicedToArray() {
  return _slicedToArray2 = _interopRequireDefault(require('babel-runtime/helpers/slicedToArray'));
}

var _regenerator;

function _load_regenerator() {
  return _regenerator = _interopRequireDefault(require('babel-runtime/regenerator'));
}

var _toConsumableArray2;

function _load_toConsumableArray() {
  return _toConsumableArray2 = _interopRequireDefault(require('babel-runtime/helpers/toConsumableArray'));
}

var _asyncToGenerator2;

function _load_asyncToGenerator() {
  return _asyncToGenerator2 = _interopRequireDefault(require('babel-runtime/helpers/asyncToGenerator'));
}

var installAsync = function () {
  var _ref = (0, (_asyncToGenerator2 || _load_asyncToGenerator()).default)( /*#__PURE__*/(_regenerator || _load_regenerator()).default.mark(function _callee(packages, options) {
    var projectRoot, _ref2, exp, packageManager, _ref3, compatible, incompatible, dependencies, nativeModules, others, versionedPackages, messages;

    return (_regenerator || _load_regenerator()).default.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            projectRoot = findProjectRoot(process.cwd());
            _context.next = 3;
            return (_config || _load_config()).readConfigJsonAsync(projectRoot);

          case 3:
            _ref2 = _context.sent;
            exp = _ref2.exp;
            packageManager = (_PackageManager || _load_PackageManager()).createForProject(projectRoot, {
              npm: options.npm,
              yarn: options.yarn
            });

            if (_fs.default.existsSync(_path.default.join(exp.nodeModulesPath || projectRoot, 'node_modules'))) {
              _context.next = 10;
              break;
            }

            (_log || _load_log()).default.warn('node_modules not found, running ' + packageManager.name + ' install command.');
            _context.next = 10;
            return packageManager.installAsync();

          case 10:
            _context.next = 12;
            return listBundledNativeModulesAsync(projectRoot, exp);

          case 12:
            _ref3 = _context.sent;
            compatible = _ref3.compatible;
            incompatible = _ref3.incompatible;
            dependencies = _ref3.dependencies;
            nativeModules = [];
            others = [];
            versionedPackages = packages.map(function (arg) {
              var spec = (0, (_npmPackageArg || _load_npmPackageArg()).default)(arg);
              var name = spec.name;

              if (['tag', 'version', 'range'].includes(spec.type) && name && (compatible[name] || incompatible[name])) {
                if (compatible[name]) {
                  // Unimodule packages from npm registry are modified to use the bundled version.
                  var version = dependencies[name];
                  var modifiedSpec = name + '@' + version;
                  nativeModules.push(modifiedSpec);
                  return modifiedSpec;
                } else {
                  throw new (_CommandError || _load_CommandError()).default('INCOMPATIBLE_NATIVE_MODULE', '\'' + name + '\' is incompatible with Expo SDK ' + exp.sdkVersion + '.\nSupported SDK versions: ' + incompatible[name].sdkVersions);
                }
              } else {
                // Other packages are passed through unmodified.
                others.push(spec.raw);
                return spec.raw;
              }
            });
            messages = [];

            if (nativeModules.length > 0) {
              messages.push(nativeModules.length + ' SDK ' + exp.sdkVersion + ' compatible native ' + (0, (_inflection || _load_inflection()).inflect)('modules', nativeModules.length));
            }
            if (others.length > 0) {
              messages.push(others.length + ' other ' + (0, (_inflection || _load_inflection()).inflect)('packages', others.length));
            }
            (0, (_log || _load_log()).default)('Installing ' + messages.join(' and ') + ' using ' + packageManager.name + '.');
            _context.next = 25;
            return packageManager.addAsync.apply(packageManager, (0, (_toConsumableArray2 || _load_toConsumableArray()).default)(versionedPackages));

          case 25:
          case 'end':
            return _context.stop();
        }
      }
    }, _callee, this);
  }));

  return function installAsync(_x, _x2) {
    return _ref.apply(this, arguments);
  };
}();

var listBundledNativeModulesAsync = function () {
  var _ref4 = (0, (_asyncToGenerator2 || _load_asyncToGenerator()).default)( /*#__PURE__*/(_regenerator || _load_regenerator()).default.mark(function _callee2(projectRoot, exp) {
    var packageJsonPath, packageJson, nativeModules, _partition, _partition2, compatibleModules, incompatibleModules;

    return (_regenerator || _load_regenerator()).default.wrap(function _callee2$(_context2) {
      while (1) {
        switch (_context2.prev = _context2.next) {
          case 0:
            packageJsonPath = (_config || _load_config()).resolveModule('expo/package.json', projectRoot, exp);

            if (packageJsonPath) {
              _context2.next = 3;
              break;
            }

            throw new (_CommandError || _load_CommandError()).default('NO_EXPO', "Package 'expo' not found in node_modules. Please make sure this is a managed Expo project.");

          case 3:
            _context2.next = 5;
            return (_jsonFile || _load_jsonFile()).default.readAsync(packageJsonPath);

          case 5:
            packageJson = _context2.sent;
            nativeModules = (_xdl || _load_xdl()).Modules.getAllNativeModules();
            _partition = (0, (_partition3 || _load_partition()).default)(nativeModules, function (moduleConfig) {
              return (_xdl || _load_xdl()).Modules.doesVersionSatisfy(exp.sdkVersion, moduleConfig.sdkVersions) && packageJson.dependencies[moduleConfig.libName];
            }), _partition2 = (0, (_slicedToArray2 || _load_slicedToArray()).default)(_partition, 2), compatibleModules = _partition2[0], incompatibleModules = _partition2[1];
            return _context2.abrupt('return', {
              compatible: (0, (_keyBy || _load_keyBy()).default)(compatibleModules, function (moduleConfig) {
                return moduleConfig.libName;
              }),
              incompatible: (0, (_keyBy || _load_keyBy()).default)(incompatibleModules, function (moduleConfig) {
                return moduleConfig.libName;
              }),
              dependencies: packageJson.dependencies
            });

          case 9:
          case 'end':
            return _context2.stop();
        }
      }
    }, _callee2, this);
  }));

  return function listBundledNativeModulesAsync(_x3, _x4) {
    return _ref4.apply(this, arguments);
  };
}();

var _config;

function _load_config() {
  return _config = _interopRequireWildcard(require('@expo/config'));
}

var _fs = _interopRequireDefault(require('fs'));

var _inflection;

function _load_inflection() {
  return _inflection = require('inflection');
}

var _jsonFile;

function _load_jsonFile() {
  return _jsonFile = _interopRequireDefault(require('@expo/json-file'));
}

var _keyBy;

function _load_keyBy() {
  return _keyBy = _interopRequireDefault(require('lodash/keyBy'));
}

var _npmPackageArg;

function _load_npmPackageArg() {
  return _npmPackageArg = _interopRequireDefault(require('npm-package-arg'));
}

var _partition3;

function _load_partition() {
  return _partition3 = _interopRequireDefault(require('lodash/partition'));
}

var _path = _interopRequireDefault(require('path'));

var _xdl;

function _load_xdl() {
  return _xdl = require('xdl');
}

var _CommandError;

function _load_CommandError() {
  return _CommandError = _interopRequireDefault(require('../CommandError'));
}

var _PackageManager;

function _load_PackageManager() {
  return _PackageManager = _interopRequireWildcard(require('../PackageManager'));
}

var _log;

function _load_log() {
  return _log = _interopRequireDefault(require('../log'));
}

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function findProjectRoot(base) {
  var previous = null;
  var dir = base;

  do {
    if (_fs.default.existsSync(_path.default.join(dir, 'app.json'))) {
      return dir;
    }
    previous = dir;
    dir = _path.default.dirname(dir);
  } while (dir !== previous);

  return base;
}

exports.default = function (program) {
  program.command('install [packages...]').option('--npm', 'Use npm to install dependencies. (default when package-lock.json exists)').option('--yarn', 'Use Yarn to install dependencies. (default when yarn.lock exists)').description('Installs a unimodule or other package to a project.').asyncAction(installAsync);
};

module.exports = exports['default'];
//# sourceMappingURL=../__sourcemaps__/commands/install.js.map
